blob: 8a0038ba9c9f500ebf7211e966434f879543e825 [file] [log] [blame]
jeffhao5d1ac922011-09-29 17:41:15 -07001#!/bin/bash
2#
3# Copyright (C) 2007 The Android Open Source Project
4#
5# Licensed under the Apache License, Version 2.0 (the "License");
6# you may not use this file except in compliance with the License.
7# You may obtain a copy of the License at
8#
9# http://www.apache.org/licenses/LICENSE-2.0
10#
11# Unless required by applicable law or agreed to in writing, software
12# distributed under the License is distributed on an "AS IS" BASIS,
13# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
14# See the License for the specific language governing permissions and
15# limitations under the License.
16
17# Set up prog to be the path of this script, including following symlinks,
18# and set up progdir to be the fully-qualified pathname of its directory.
19prog="$0"
Andreas Gampedeb48a02014-10-22 00:44:35 -070020args="$@"
jeffhao5d1ac922011-09-29 17:41:15 -070021while [ -h "${prog}" ]; do
22 newProg=`/bin/ls -ld "${prog}"`
23 newProg=`expr "${newProg}" : ".* -> \(.*\)$"`
24 if expr "x${newProg}" : 'x/' >/dev/null; then
25 prog="${newProg}"
26 else
27 progdir=`dirname "${prog}"`
28 prog="${progdir}/${newProg}"
29 fi
30done
31oldwd=`pwd`
32progdir=`dirname "${prog}"`
33cd "${progdir}"
34progdir=`pwd`
35prog="${progdir}"/`basename "${prog}"`
Brian Carlstrom105215d2012-06-14 12:50:44 -070036test_dir="test-$$"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070037if [ -z "$TMPDIR" ]; then
38 tmp_dir="/tmp/$USER/${test_dir}"
39else
Andreas Gampe34a8a0f2016-07-20 21:09:29 -070040 tmp_dir="${TMPDIR}/${test_dir}"
Andreas Gampe5a79fde2014-08-06 13:12:26 -070041fi
David Srbeckyca15b8d2021-04-23 12:25:08 +010042build_path="${tmp_dir}-build"
David Brazdil2c27f2c2015-05-12 18:06:38 +010043checker="${progdir}/../tools/checker/checker.py"
jeffhao5d1ac922011-09-29 17:41:15 -070044export JAVA="java"
Orion Hodson64fe3be2018-06-15 12:50:22 +010045export JAVAC="javac -g -Xlint:-options -source 1.8 -target 1.8"
Nicolas Geoffray1a58b7f2014-10-06 12:23:04 +010046export RUN="${progdir}/etc/run-test-jar"
Brian Carlstrom105215d2012-06-14 12:50:44 -070047export DEX_LOCATION=/data/run-test/${test_dir}
Elliott Hughesc717eef2012-06-15 16:01:26 -070048export NEED_DEX="true"
Alan Leungcf2de162018-03-30 20:18:20 +000049export USE_D8="true"
Igor Murashkin2a337752017-06-16 14:34:40 +000050export USE_DESUGAR="true"
Ben Gruver14fc9db2017-04-28 15:30:49 -070051export SMALI_ARGS=""
jeffhao5d1ac922011-09-29 17:41:15 -070052
Alan Leungd5cbc562018-03-15 14:02:46 -070053# If d8 was not set by the environment variable, assume it is in the path.
54if [ -z "$D8" ]; then
55 export D8="d8"
56fi
57
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070058# If dx was not set by the environment variable, assume it is in the path.
59if [ -z "$DX" ]; then
Orion Hodson64fe3be2018-06-15 12:50:22 +010060 export DX="d8-compat-dx"
Tsu Chiang Chuang4407e612012-07-19 16:13:43 -070061fi
62
Orion Hodson64fe3be2018-06-15 12:50:22 +010063export DEXMERGER="$D8"
Alan Leungd5cbc562018-03-15 14:02:46 -070064
Tsu Chiang Chuang6674f8a2013-01-16 15:41:21 -080065# If jasmin was not set by the environment variable, assume it is in the path.
66if [ -z "$JASMIN" ]; then
67 export JASMIN="jasmin"
68fi
69
Andreas Gampe8fda9f22014-10-03 16:15:37 -070070# If smali was not set by the environment variable, assume it is in the path.
71if [ -z "$SMALI" ]; then
72 export SMALI="smali"
73fi
74
Sebastien Hertz19ac0272015-02-24 17:39:50 +010075# ANDROID_BUILD_TOP is not set in a build environment.
76if [ -z "$ANDROID_BUILD_TOP" ]; then
77 export ANDROID_BUILD_TOP=$oldwd
78fi
79
Dan Willemsen12371e92017-03-06 17:55:20 -080080# OUT_DIR defaults to out, and may be relative to $ANDROID_BUILD_TOP.
81# Convert it to an absolute path, since we cd into the tmp_dir to run the tests.
82export OUT_DIR=${OUT_DIR:-out}
83if [[ "$OUT_DIR" != /* ]]; then
84 export OUT_DIR=$ANDROID_BUILD_TOP/$OUT_DIR
85fi
86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070087# ANDROID_HOST_OUT is not set in a build environment.
88if [ -z "$ANDROID_HOST_OUT" ]; then
Dan Willemsen12371e92017-03-06 17:55:20 -080089 export ANDROID_HOST_OUT=${OUT_DIR}/host/linux-x86
Andreas Gampef47fb2f2016-06-24 22:30:29 -070090fi
91
Alex Light680cbf22018-10-31 11:00:19 -070092host_lib_root=${ANDROID_HOST_OUT}
93
Igor Murashkine5181932017-06-15 16:03:50 -070094# Allow changing DESUGAR script to something else, or to disable it with DESUGAR=false.
Igor Murashkind3232772017-06-22 14:54:13 -070095if [ -z "$DESUGAR" ]; then
Igor Murashkine5181932017-06-15 16:03:50 -070096 export DESUGAR="$ANDROID_BUILD_TOP/art/tools/desugar.sh"
97fi
98
Igor Murashkin271a0f82017-02-14 21:14:17 +000099# Zipalign is not on the PATH in some configs, auto-detect it.
100if [ -z "$ZIPALIGN" ]; then
101 if which zipalign >/dev/null; then
102 ZIPALIGN="zipalign";
103 else
104 # TODO: Add a dependency for zipalign in Android.run-test.mk
105 # once it doesn't depend on libandroidfw (b/35246701)
106 case "$OSTYPE" in
107 darwin*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/darwin/bin/zipalign" ;;
108 linux*) ZIPALIGN="$ANDROID_BUILD_TOP/prebuilts/sdk/tools/linux/bin/zipalign" ;;
109 *) echo "Can't find zipalign: unknown: $OSTYPE" >&2;;
110 esac
111 fi
112fi
113export ZIPALIGN
114
David Brazdil122c6632018-01-24 17:32:49 +0000115# If hiddenapi was not set by the environment variable, assume it is in
116# ANDROID_HOST_OUT.
David Brazdil11b67b22018-01-18 16:41:40 +0000117if [ -z "$HIDDENAPI" ]; then
David Brazdil122c6632018-01-24 17:32:49 +0000118 export HIDDENAPI="${ANDROID_HOST_OUT}/bin/hiddenapi"
David Brazdil11b67b22018-01-18 16:41:40 +0000119fi
120
David Srbecky8d3d64f2021-07-29 15:46:48 +0100121export SOONG_ZIP="$ANDROID_BUILD_TOP/prebuilts/build-tools/linux-x86/bin/soong_zip"
122
Roland Levillain76cfe612017-10-30 13:14:28 +0000123chroot=
124
jeffhao5d1ac922011-09-29 17:41:15 -0700125info="info.txt"
126build="build"
127run="run"
Roland Levillainb15e8792020-10-28 12:20:59 +0000128expected_stdout="expected-stdout.txt"
129expected_stderr="expected-stderr.txt"
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700130check_cmd="check"
Roland Levillainb15e8792020-10-28 12:20:59 +0000131test_stdout="test-stdout.txt"
132test_stderr="test-stderr.txt"
133build_stdout="build-stdout.txt"
134build_stderr="build-stderr.txt"
David Brazdil24128c62015-05-21 12:06:13 +0100135cfg_output="graph.cfg"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700136strace_output="strace-output.txt"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700137lib="libartd.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700138testlib="arttestd"
Andreas Gampe11410de2019-07-02 15:53:53 -0700139run_args=(--quiet)
David Brazdil4846d132015-01-15 19:07:08 +0000140build_args=""
jeffhao5d1ac922011-09-29 17:41:15 -0700141
Alex Light91de25f2015-10-28 17:00:06 -0700142quiet="no"
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000143debuggable="no"
Alex Light9d722532014-07-22 18:07:12 -0700144prebuild_mode="yes"
Brian Carlstrom2613de42012-06-15 17:37:16 -0700145target_mode="yes"
jeffhao5d1ac922011-09-29 17:41:15 -0700146dev_mode="no"
Alex Light8d94ddd2019-12-18 11:13:03 -0800147create_runner="no"
jeffhao5d1ac922011-09-29 17:41:15 -0700148update_mode="no"
Alex Lighta59dd802014-07-02 16:28:08 -0700149debug_mode="no"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000150relocate="no"
Jeff Hao201803f2013-11-20 18:11:39 -0800151runtime="art"
jeffhao5d1ac922011-09-29 17:41:15 -0700152usage="no"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700153build_only="no"
David Srbeckyca15b8d2021-04-23 12:25:08 +0100154skip_build="no"
Andreas Gampe2fe07922014-04-21 07:50:39 -0700155suffix64=""
Jeff Hao85139a32014-07-23 11:52:52 -0700156trace="false"
Andreas Gampe7526d782015-06-22 22:53:45 -0700157trace_stream="false"
Alex Lighte7873ec2014-08-12 09:53:50 -0700158basic_verify="false"
159gc_verify="false"
160gc_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700161jvmti_trace_stress="false"
Alex Light43e935d2017-06-19 15:40:40 -0700162jvmti_field_stress="false"
Alex Lightc38c3692017-06-27 15:45:14 -0700163jvmti_step_stress="false"
Alex Lightb7edcda2017-04-27 13:20:31 -0700164jvmti_redefine_stress="false"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700165strace="false"
Alex Lightbfac14a2014-07-30 09:41:21 -0700166always_clean="no"
Igor Murashkin05f30e12015-06-10 15:57:17 -0700167never_clean="no"
Alex Light03a112d2014-08-25 13:25:56 -0700168have_image="yes"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000169android_root="/system"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700170bisection_search="no"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100171timeout=""
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800172suspend_timeout="500000"
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100173run_optimizing="false"
Stelios Ioannou1b621222021-06-17 14:15:45 +0100174dump_cfg="false"
175dump_cfg_path=""
Alex Light20802ca2018-12-05 15:36:03 -0800176# To cause tests to fail fast, limit the file sizes created by dx, dex2oat and
177# ART output to approximately 128MB. This should be more than sufficient
178# for any test while still catching cases of runaway output.
179# Set a hard limit to encourage ART developers to increase the ulimit here if
180# needed to support a test case rather than resetting the limit in the run
181# script for the particular test in question. Adjust this if needed for
182# particular configurations.
183file_ulimit=128000
184
Andreas Gampe11410de2019-07-02 15:53:53 -0700185
jeffhao5d1ac922011-09-29 17:41:15 -0700186while true; do
187 if [ "x$1" = "x--host" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700188 target_mode="no"
TDYa127b92bcab2012-04-08 00:09:51 -0700189 DEX_LOCATION=$tmp_dir
Andreas Gampe11410de2019-07-02 15:53:53 -0700190 run_args+=(--host)
jeffhao5d1ac922011-09-29 17:41:15 -0700191 shift
Alex Light91de25f2015-10-28 17:00:06 -0700192 elif [ "x$1" = "x--quiet" ]; then
193 quiet="yes"
194 shift
Alex Lighteb7c1442015-08-31 13:17:42 -0700195 elif [ "x$1" = "x--use-java-home" ]; then
196 if [ -n "${JAVA_HOME}" ]; then
197 export JAVA="${JAVA_HOME}/bin/java"
198 export JAVAC="${JAVA_HOME}/bin/javac -g"
199 else
200 echo "Passed --use-java-home without JAVA_HOME variable set!"
201 usage="yes"
202 fi
203 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800204 elif [ "x$1" = "x--jvm" ]; then
Brian Carlstrom2613de42012-06-15 17:37:16 -0700205 target_mode="no"
Alex Light2c7aaeb2017-01-27 14:08:17 -0800206 DEX_LOCATION="$tmp_dir"
Jeff Hao201803f2013-11-20 18:11:39 -0800207 runtime="jvm"
Brian Carlstrom01afdba2014-10-03 10:28:47 -0700208 prebuild_mode="no"
Elliott Hughesc717eef2012-06-15 16:01:26 -0700209 NEED_DEX="false"
Andreas Gampe11410de2019-07-02 15:53:53 -0700210 run_args+=(--jvm)
jeffhao5d1ac922011-09-29 17:41:15 -0700211 shift
Elliott Hughes58bcc402012-02-14 14:10:10 -0800212 elif [ "x$1" = "x-O" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700213 lib="libart.so"
Mathieu Chartier031768a2015-08-27 10:25:02 -0700214 testlib="arttest"
Andreas Gampe11410de2019-07-02 15:53:53 -0700215 run_args+=(-O)
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700216 shift
217 elif [ "x$1" = "x--dalvik" ]; then
218 lib="libdvm.so"
Jeff Hao201803f2013-11-20 18:11:39 -0800219 runtime="dalvik"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700220 shift
Alex Light03a112d2014-08-25 13:25:56 -0700221 elif [ "x$1" = "x--no-image" ]; then
222 have_image="no"
223 shift
Alex Lighta59dd802014-07-02 16:28:08 -0700224 elif [ "x$1" = "x--relocate" ]; then
225 relocate="yes"
226 shift
227 elif [ "x$1" = "x--no-relocate" ]; then
228 relocate="no"
229 shift
230 elif [ "x$1" = "x--prebuild" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700231 run_args+=(--prebuild)
Alex Lighta59dd802014-07-02 16:28:08 -0700232 prebuild_mode="yes"
233 shift;
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800234 elif [ "x$1" = "x--compact-dex-level" ]; then
235 option="$1"
236 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700237 run_args+=("$option" "$1")
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800238 shift;
Richard Uhler76f5cb62016-04-04 13:30:16 -0700239 elif [ "x$1" = "x--strip-dex" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700240 run_args+=(--strip-dex)
Richard Uhler76f5cb62016-04-04 13:30:16 -0700241 shift;
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000242 elif [ "x$1" = "x--debuggable" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700243 run_args+=(-Xcompiler-option --debuggable)
Nicolas Geoffraya3d90fb2015-03-16 13:55:40 +0000244 debuggable="yes"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000245 shift;
Alex Lighta59dd802014-07-02 16:28:08 -0700246 elif [ "x$1" = "x--no-prebuild" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700247 run_args+=(--no-prebuild)
Alex Lighta59dd802014-07-02 16:28:08 -0700248 prebuild_mode="no"
249 shift;
Alex Lighte7873ec2014-08-12 09:53:50 -0700250 elif [ "x$1" = "x--gcverify" ]; then
251 basic_verify="true"
252 gc_verify="true"
253 shift
254 elif [ "x$1" = "x--gcstress" ]; then
255 basic_verify="true"
256 gc_stress="true"
257 shift
Alex Lightc38c3692017-06-27 15:45:14 -0700258 elif [ "x$1" = "x--jvmti-step-stress" ]; then
259 jvmti_step_stress="true"
260 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700261 elif [ "x$1" = "x--jvmti-redefine-stress" ]; then
262 jvmti_redefine_stress="true"
263 shift
Alex Light43e935d2017-06-19 15:40:40 -0700264 elif [ "x$1" = "x--jvmti-field-stress" ]; then
265 jvmti_field_stress="true"
266 shift
Alex Lightb7edcda2017-04-27 13:20:31 -0700267 elif [ "x$1" = "x--jvmti-trace-stress" ]; then
268 jvmti_trace_stress="true"
Alex Light8f2c6d42017-04-10 16:27:35 -0700269 shift
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800270 elif [ "x$1" = "x--suspend-timeout" ]; then
271 shift
272 suspend_timeout="$1"
273 shift
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700274 elif [ "x$1" = "x--image" ]; then
275 shift
276 image="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700277 run_args+=(--image "$image")
Elliott Hughes7c046102011-10-19 18:16:03 -0700278 shift
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000279 elif [ "x$1" = "x-Xcompiler-option" ]; then
280 shift
281 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700282 run_args+=(-Xcompiler-option "$option")
Nicolas Geoffray92cf83e2014-03-18 17:59:20 +0000283 shift
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000284 elif [ "x$1" = "x--build-option" ]; then
285 shift
286 option="$1"
287 build_args="${build_args} $option"
288 shift
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700289 elif [ "x$1" = "x--runtime-option" ]; then
290 shift
291 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700292 run_args+=(--runtime-option "$option")
Mathieu Chartier769a5ad2014-05-18 15:30:10 -0700293 shift
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700294 elif [ "x$1" = "x--gdb-arg" ]; then
295 shift
296 gdb_arg="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700297 run_args+=(--gdb-arg "$gdb_arg")
Mathieu Chartierc0a8a802014-10-17 15:58:01 -0700298 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700299 elif [ "x$1" = "x--debug" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700300 run_args+=(--debug)
jeffhao5d1ac922011-09-29 17:41:15 -0700301 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700302 elif [ "x$1" = "x--debug-wrap-agent" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700303 run_args+=(--debug-wrap-agent)
Alex Lightc281ba52017-10-11 11:35:55 -0700304 shift
Alex Light0e151e72017-10-25 10:50:35 -0700305 elif [ "x$1" = "x--with-agent" ]; then
306 shift
307 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700308 run_args+=(--with-agent "$1")
Alex Light0e151e72017-10-25 10:50:35 -0700309 shift
Alex Lightc281ba52017-10-11 11:35:55 -0700310 elif [ "x$1" = "x--debug-agent" ]; then
311 shift
312 option="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700313 run_args+=(--debug-agent "$1")
Alex Lightc281ba52017-10-11 11:35:55 -0700314 shift
Stelios Ioannou1b621222021-06-17 14:15:45 +0100315 elif [ "x$1" = "x--dump-cfg" ]; then
316 shift
317 dump_cfg="true"
318 dump_cfg_path="$1"
319 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700320 elif [ "x$1" = "x--gdb" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700321 run_args+=(--gdb)
jeffhao5d1ac922011-09-29 17:41:15 -0700322 dev_mode="yes"
323 shift
Alex Lighte4b4a182019-02-12 14:19:49 -0800324 elif [ "x$1" = "x--gdbserver-bin" ]; then
325 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700326 run_args+=(--gdbserver-bin "$1")
Alex Lighte4b4a182019-02-12 14:19:49 -0800327 shift
328 elif [ "x$1" = "x--gdbserver-port" ]; then
329 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700330 run_args+=(--gdbserver-port "$1")
Alex Lighte4b4a182019-02-12 14:19:49 -0800331 shift
332 elif [ "x$1" = "x--gdbserver" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700333 run_args+=(--gdbserver)
Alex Lighte4b4a182019-02-12 14:19:49 -0800334 dev_mode="yes"
335 shift
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700336 elif [ "x$1" = "x--strace" ]; then
337 strace="yes"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100338 run_args+=(--invoke-with strace --invoke-with -o --invoke-with "$tmp_dir/$strace_output")
339 timeout="${timeout:-1800}"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -0700340 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700341 elif [ "x$1" = "x--zygote" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700342 run_args+=(--zygote)
jeffhao5d1ac922011-09-29 17:41:15 -0700343 shift
jeffhao0dff3f42012-11-20 15:13:43 -0800344 elif [ "x$1" = "x--interpreter" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700345 run_args+=(--interpreter)
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700346 shift
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800347 elif [ "x$1" = "x--jit" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700348 run_args+=(--jit)
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800349 shift
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100350 elif [ "x$1" = "x--baseline" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700351 run_args+=(--baseline)
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100352 shift
Andreas Gampe63fc30e2014-10-24 21:58:16 -0700353 elif [ "x$1" = "x--optimizing" ]; then
Nicolas Geoffrayacc56ac2018-10-09 08:45:24 +0100354 run_optimizing="true"
jeffhao0dff3f42012-11-20 15:13:43 -0800355 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700356 elif [ "x$1" = "x--no-verify" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700357 run_args+=(--no-verify)
jeffhao5d1ac922011-09-29 17:41:15 -0700358 shift
Igor Murashkin7617abd2015-07-10 18:27:47 -0700359 elif [ "x$1" = "x--verify-soft-fail" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700360 run_args+=(--verify-soft-fail)
Igor Murashkin7617abd2015-07-10 18:27:47 -0700361 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700362 elif [ "x$1" = "x--no-optimize" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700363 run_args+=(--no-optimize)
jeffhao5d1ac922011-09-29 17:41:15 -0700364 shift
365 elif [ "x$1" = "x--no-precise" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700366 run_args+=(--no-precise)
jeffhao5d1ac922011-09-29 17:41:15 -0700367 shift
Orion Hodson9ca92fb2020-10-28 15:08:11 +0000368 elif [ "x$1" = "x--external-log-tags" ]; then
369 run_args+=(--external-log-tags)
370 shift
Elliott Hughes7c046102011-10-19 18:16:03 -0700371 elif [ "x$1" = "x--invoke-with" ]; then
372 shift
373 what="$1"
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700374 if [ "x$what" = "x" ]; then
375 echo "$0 missing argument to --invoke-with" 1>&2
376 usage="yes"
377 break
378 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700379 run_args+=(--invoke-with "${what}")
jeffhao5d1ac922011-09-29 17:41:15 -0700380 shift
Alex Light8d94ddd2019-12-18 11:13:03 -0800381 elif [ "x$1" = "x--create-runner" ]; then
382 run_args+=(--create-runner --dry-run)
383 dev_mode="yes"
384 never_clean="yes"
385 create_runner="yes"
386 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700387 elif [ "x$1" = "x--dev" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700388 run_args+=(--dev)
jeffhao5d1ac922011-09-29 17:41:15 -0700389 dev_mode="yes"
390 shift
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700391 elif [ "x$1" = "x--build-only" ]; then
392 build_only="yes"
393 shift
David Srbeckyca15b8d2021-04-23 12:25:08 +0100394 elif [ "x$1" = "x--skip-build" ]; then
395 skip_build="yes"
396 shift
397 elif [ "x$1" = "x--build-path" ]; then
398 shift
399 build_path=$1
400 if [ "x$build_path" = "x" ]; then
401 echo "$0 missing argument to --build-path" 1>&2
402 usage="yes"
403 break
404 fi
405 shift
406 elif [ "x$1" = "x--temp-path" ]; then
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700407 shift
408 tmp_dir=$1
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700409 if [ "x$tmp_dir" = "x" ]; then
David Srbeckyca15b8d2021-04-23 12:25:08 +0100410 echo "$0 missing argument to --temp-path" 1>&2
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700411 usage="yes"
412 break
413 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -0700414 shift
Roland Levillain76cfe612017-10-30 13:14:28 +0000415 elif [ "x$1" = "x--chroot" ]; then
416 shift
417 if [ "x$1" = "x" ]; then
418 echo "$0 missing argument to --chroot" 1>&2
419 usage="yes"
420 break
421 fi
422 chroot="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700423 run_args+=(--chroot "$1")
Roland Levillain76cfe612017-10-30 13:14:28 +0000424 shift
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000425 elif [ "x$1" = "x--android-root" ]; then
426 shift
427 if [ "x$1" = "x" ]; then
428 echo "$0 missing argument to --android-root" 1>&2
429 usage="yes"
430 break
431 fi
432 android_root="$1"
Andreas Gampe11410de2019-07-02 15:53:53 -0700433 run_args+=(--android-root "$1")
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000434 shift
Martin Stjernholme58624f2019-09-20 15:53:40 +0100435 elif [ "x$1" = "x--android-art-root" ]; then
Roland Levillain28076142019-01-10 16:39:25 +0000436 shift
437 if [ "x$1" = "x" ]; then
Martin Stjernholme58624f2019-09-20 15:53:40 +0100438 echo "$0 missing argument to --android-art-root" 1>&2
Roland Levillain28076142019-01-10 16:39:25 +0000439 usage="yes"
440 break
441 fi
Martin Stjernholme58624f2019-09-20 15:53:40 +0100442 run_args+=(--android-art-root "$1")
Roland Levillain28076142019-01-10 16:39:25 +0000443 shift
Roland Levillain90b34572019-06-14 15:23:15 +0100444 elif [ "x$1" = "x--android-tzdata-root" ]; then
445 shift
446 if [ "x$1" = "x" ]; then
447 echo "$0 missing argument to --android-tzdata-root" 1>&2
448 usage="yes"
449 break
450 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700451 run_args+=(--android-tzdata-root "$1")
Roland Levillain90b34572019-06-14 15:23:15 +0100452 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700453 elif [ "x$1" = "x--update" ]; then
454 update_mode="yes"
455 shift
456 elif [ "x$1" = "x--help" ]; then
457 usage="yes"
458 shift
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700459 elif [ "x$1" = "x--64" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700460 run_args+=(--64)
Andreas Gampe2fe07922014-04-21 07:50:39 -0700461 suffix64="64"
Andreas Gampeafbaa1a2014-03-25 18:09:32 -0700462 shift
Alex Light680cbf22018-10-31 11:00:19 -0700463 elif [ "x$1" = "x--bionic" ]; then
464 # soong linux_bionic builds are 64bit only.
Andreas Gampe11410de2019-07-02 15:53:53 -0700465 run_args+=(--bionic --host --64)
Alex Light680cbf22018-10-31 11:00:19 -0700466 suffix64="64"
467 target_mode="no"
468 DEX_LOCATION=$tmp_dir
469 host_lib_root=$OUT_DIR/soong/host/linux_bionic-x86
470 shift
Alex Light6f342dd2019-03-27 17:15:42 +0000471 elif [ "x$1" = "x--runtime-extracted-zipapex" ]; then
472 shift
473 # TODO Should we allow the java.library.path to search the zipapex too?
474 # Not needed at the moment and adding it will be complicated so for now
475 # we'll ignore this.
Andreas Gampe11410de2019-07-02 15:53:53 -0700476 run_args+=(--host --runtime-extracted-zipapex "$1")
Alex Light6f342dd2019-03-27 17:15:42 +0000477 target_mode="no"
478 DEX_LOCATION=$tmp_dir
479 shift
Alex Light20802ca2018-12-05 15:36:03 -0800480 elif [ "x$1" = "x--runtime-zipapex" ]; then
481 shift
482 # TODO Should we allow the java.library.path to search the zipapex too?
483 # Not needed at the moment and adding it will be complicated so for now
484 # we'll ignore this.
Andreas Gampe11410de2019-07-02 15:53:53 -0700485 run_args+=(--host --runtime-zipapex "$1")
Alex Light20802ca2018-12-05 15:36:03 -0800486 target_mode="no"
487 DEX_LOCATION=$tmp_dir
488 # apex_payload.zip is quite large we need a high enough ulimit to
489 # extract it. 512mb should be good enough.
490 file_ulimit=512000
491 shift
Martin Stjernholm4815e722019-09-24 16:20:09 +0100492 elif [ "x$1" = "x--timeout" ]; then
493 shift
494 if [ "x$1" = "x" ]; then
495 echo "$0 missing argument to --timeout" 1>&2
496 usage="yes"
497 break
498 fi
499 timeout="$1"
500 shift
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200501 elif [ "x$1" = "x--trace" ]; then
Jeff Hao85139a32014-07-23 11:52:52 -0700502 trace="true"
Sebastien Hertz07aaac82014-07-09 15:59:05 +0200503 shift
Andreas Gampe7526d782015-06-22 22:53:45 -0700504 elif [ "x$1" = "x--stream" ]; then
505 trace_stream="true"
506 shift
Alex Lightbfac14a2014-07-30 09:41:21 -0700507 elif [ "x$1" = "x--always-clean" ]; then
508 always_clean="yes"
509 shift
Igor Murashkin05f30e12015-06-10 15:57:17 -0700510 elif [ "x$1" = "x--never-clean" ]; then
511 never_clean="yes"
512 shift
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800513 elif [ "x$1" = "x--dex2oat-swap" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700514 run_args+=(--dex2oat-swap)
Andreas Gampee21dc3d2014-12-08 16:59:43 -0800515 shift
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700516 elif [ "x$1" = "x--instruction-set-features" ]; then
517 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700518 run_args+=(--instruction-set-features "$1")
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700519 shift
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700520 elif [ "x$1" = "x--bisection-search" ]; then
521 bisection_search="yes"
522 shift
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000523 elif [ "x$1" = "x--vdex" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700524 run_args+=(--vdex)
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000525 shift
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000526 elif [ "x$1" = "x--dm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700527 run_args+=(--dm)
Nicolas Geoffraybaeaa9b2018-01-26 14:31:17 +0000528 shift
Nicolas Geoffray74981052017-01-16 17:54:09 +0000529 elif [ "x$1" = "x--vdex-filter" ]; then
530 shift
531 filter=$1
Andreas Gampe11410de2019-07-02 15:53:53 -0700532 run_args+=(--vdex-filter "$filter")
Nicolas Geoffray74981052017-01-16 17:54:09 +0000533 shift
Jeff Hao002b9312017-03-27 16:23:08 -0700534 elif [ "x$1" = "x--random-profile" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700535 run_args+=(--random-profile)
Jeff Hao002b9312017-03-27 16:23:08 -0700536 shift
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700537 elif [ "x$1" = "x--dex2oat-jobs" ]; then
538 shift
Andreas Gampe11410de2019-07-02 15:53:53 -0700539 run_args+=(-Xcompiler-option "-j$1")
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700540 shift
jeffhao5d1ac922011-09-29 17:41:15 -0700541 elif expr "x$1" : "x--" >/dev/null 2>&1; then
Elliott Hughes7c046102011-10-19 18:16:03 -0700542 echo "unknown $0 option: $1" 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700543 usage="yes"
544 break
545 else
546 break
547 fi
548done
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700549
Orion Hodson6aa4e0d2018-05-25 09:39:16 +0100550if [ "$usage" = "no" -a "x$1" = "x" ]; then
551 echo "missing test to run" 1>&2
552 usage="yes"
553fi
554
Roland Levillain76cfe612017-10-30 13:14:28 +0000555# The DEX_LOCATION with the chroot prefix, if any.
556chroot_dex_location="$chroot$DEX_LOCATION"
557
Alex Light91de25f2015-10-28 17:00:06 -0700558# Allocate file descriptor real_stderr and redirect it to the shell's error
559# output (fd 2).
560if [ ${BASH_VERSINFO[1]} -ge 4 ] && [ ${BASH_VERSINFO[2]} -ge 1 ]; then
561 exec {real_stderr}>&2
562else
563 # In bash before version 4.1 we need to do a manual search for free file
564 # descriptors.
565 FD=3
566 while [ -e /dev/fd/$FD ]; do FD=$((FD + 1)); done
567 real_stderr=$FD
568 eval "exec ${real_stderr}>&2"
569fi
570if [ "$quiet" = "yes" ]; then
571 # Force the default standard output and error to go to /dev/null so we will
572 # not print them.
573 exec 1>/dev/null
574 exec 2>/dev/null
575fi
576
577function err_echo() {
578 echo "$@" 1>&${real_stderr}
579}
580
Andreas Gampe3a12cfe2014-08-13 15:40:22 -0700581# tmp_dir may be relative, resolve.
582#
583# Cannot use realpath, as it does not exist on Mac.
Roland Levillain76cfe612017-10-30 13:14:28 +0000584# Cannot use a simple "cd", as the path might not be created yet.
Brian Carlstromc580e042014-09-08 21:37:39 -0700585# Cannot use readlink -m, as it does not exist on Mac.
586# Fallback to nuclear option:
Andreas Gampe907b6992014-08-18 22:26:49 -0700587noncanonical_tmp_dir=$tmp_dir
Vladimir Markoefbc6592021-04-16 10:29:13 +0000588tmp_dir="`cd $oldwd ; python3 -c "import os; import sys; sys.stdout.write(os.path.realpath('$tmp_dir'))"`"
Andreas Gampe86459c02019-08-29 14:01:18 -0700589if [ -z $tmp_dir ] ; then
590 err_echo "Failed to resolve $tmp_dir"
591 exit 1
592fi
Dmitry Petrochenko81c56e72014-03-05 15:05:46 +0700593mkdir -p $tmp_dir
jeffhao5d1ac922011-09-29 17:41:15 -0700594
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800595# Add thread suspend timeout flag
Narayan Kamathf86c3932017-01-24 17:40:47 +0000596if [ ! "$runtime" = "jvm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700597 run_args+=(--runtime-option "-XX:ThreadSuspendTimeout=$suspend_timeout")
Narayan Kamathf86c3932017-01-24 17:40:47 +0000598fi
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800599
Alex Lighte7873ec2014-08-12 09:53:50 -0700600if [ "$basic_verify" = "true" ]; then
Hiroshi Yamauchi312baf12015-01-12 12:11:05 -0800601 # Set HspaceCompactForOOMMinIntervalMs to zero to run hspace compaction for OOM more frequently in tests.
Andreas Gampe11410de2019-07-02 15:53:53 -0700602 run_args+=(--runtime-option -Xgc:preverify --runtime-option -Xgc:postverify --runtime-option -XX:HspaceCompactForOOMMinIntervalMs=0)
Alex Lighte7873ec2014-08-12 09:53:50 -0700603fi
604if [ "$gc_verify" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700605 run_args+=(--runtime-option -Xgc:preverify_rosalloc --runtime-option -Xgc:postverify_rosalloc)
Alex Lighte7873ec2014-08-12 09:53:50 -0700606fi
607if [ "$gc_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700608 run_args+=(--gc-stress --runtime-option -Xgc:gcstress --runtime-option -Xms2m --runtime-option -Xmx16m)
Alex Lighte7873ec2014-08-12 09:53:50 -0700609fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700610if [ "$jvmti_redefine_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700611 run_args+=(--no-app-image --jvmti-redefine-stress)
Alex Lightb7edcda2017-04-27 13:20:31 -0700612fi
Alex Lightc38c3692017-06-27 15:45:14 -0700613if [ "$jvmti_step_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700614 run_args+=(--no-app-image --jvmti-step-stress)
Alex Lightc38c3692017-06-27 15:45:14 -0700615fi
Alex Light43e935d2017-06-19 15:40:40 -0700616if [ "$jvmti_field_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700617 run_args+=(--no-app-image --jvmti-field-stress)
Alex Light43e935d2017-06-19 15:40:40 -0700618fi
Alex Lightb7edcda2017-04-27 13:20:31 -0700619if [ "$jvmti_trace_stress" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700620 run_args+=(--no-app-image --jvmti-trace-stress)
Alex Light8f2c6d42017-04-10 16:27:35 -0700621fi
Jeff Hao85139a32014-07-23 11:52:52 -0700622if [ "$trace" = "true" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700623 run_args+=(--runtime-option -Xmethod-trace --runtime-option -Xmethod-trace-file-size:2000000)
Andreas Gampe7526d782015-06-22 22:53:45 -0700624 if [ "$trace_stream" = "true" ]; then
625 # Streaming mode uses the file size as the buffer size. So output gets really large. Drop
626 # the ability to analyze the file and just write to /dev/null.
Andreas Gampe11410de2019-07-02 15:53:53 -0700627 run_args+=(--runtime-option -Xmethod-trace-file:/dev/null)
Andreas Gampe7526d782015-06-22 22:53:45 -0700628 # Enable streaming mode.
Andreas Gampe11410de2019-07-02 15:53:53 -0700629 run_args+=(--runtime-option -Xmethod-trace-stream)
Andreas Gampe7526d782015-06-22 22:53:45 -0700630 else
Andreas Gampe11410de2019-07-02 15:53:53 -0700631 run_args+=(--runtime-option "-Xmethod-trace-file:${DEX_LOCATION}/trace.bin")
Andreas Gampe7526d782015-06-22 22:53:45 -0700632 fi
633elif [ "$trace_stream" = "true" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700634 err_echo "Cannot use --stream without --trace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700635 exit 1
Jeff Hao85139a32014-07-23 11:52:52 -0700636fi
Martin Stjernholm4815e722019-09-24 16:20:09 +0100637if [ -n "$timeout" ]; then
638 run_args+=(--timeout "$timeout")
639fi
Jeff Hao85139a32014-07-23 11:52:52 -0700640
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700641# Most interesting target architecture variables are Makefile variables, not environment variables.
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000642# Try to map the suffix64 flag and what we find in ${ANDROID_PRODUCT_OUT}/data/art-test to an architecture name.
David Brazdil853a4c32015-09-28 16:15:50 +0100643function guess_target_arch_name() {
Andreas Gamped0566d42018-06-06 09:54:34 -0700644 # Check whether this is a device with native bridge. Currently this is hardcoded
645 # to x86 + arm.
David Srbecky928d28e2020-04-01 17:50:51 +0100646 local guess_path=${ANDROID_PRODUCT_OUT}/system/apex/com.android.art.testing/javalib
647 local x86_arm=`ls ${guess_path} | sort | grep -E '^(arm|x86)$'`
Andreas Gamped0566d42018-06-06 09:54:34 -0700648 # Collapse line-breaks into spaces
649 x86_arm=$(echo $x86_arm)
650 if [ "x$x86_arm" = "xarm x86" ] ; then
651 err_echo "Native-bridge configuration detected."
652 # We only support the main arch for tests.
653 if [ "x${suffix64}" = "x64" ]; then
654 target_arch_name=""
655 else
656 target_arch_name=x86
657 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700658 else
David Srbecky928d28e2020-04-01 17:50:51 +0100659 local grep32bit=`ls ${guess_path} | grep -E '^(arm|x86)$'`
660 local grep64bit=`ls ${guess_path} | grep -E '^(arm64|x86_64)$'`
Andreas Gamped0566d42018-06-06 09:54:34 -0700661 if [ "x${suffix64}" = "x64" ]; then
662 target_arch_name=${grep64bit}
663 else
664 target_arch_name=${grep32bit}
665 fi
Andreas Gampe1c83cbc2014-07-22 18:52:29 -0700666 fi
667}
668
David Brazdil853a4c32015-09-28 16:15:50 +0100669function guess_host_arch_name() {
670 if [ "x${suffix64}" = "x64" ]; then
671 host_arch_name="x86_64"
672 else
673 host_arch_name="x86"
674 fi
675}
676
Alex Lighta59dd802014-07-02 16:28:08 -0700677if [ "$target_mode" = "no" ]; then
678 if [ "$runtime" = "jvm" ]; then
Alex Lighta59dd802014-07-02 16:28:08 -0700679 if [ "$prebuild_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700680 err_echo "--prebuild with --jvm is unsupported"
Roland Levillain76cfe612017-10-30 13:14:28 +0000681 exit 1
682 fi
683 else
684 # ART/Dalvik host mode.
685 if [ -n "$chroot" ]; then
686 err_echo "--chroot with --host is unsupported"
687 exit 1
Alex Lighta59dd802014-07-02 16:28:08 -0700688 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700689 fi
690fi
691
Jeff Hao201803f2013-11-20 18:11:39 -0800692if [ ! "$runtime" = "jvm" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700693 run_args+=(--lib "$lib")
Jeff Hao201803f2013-11-20 18:11:39 -0800694fi
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700695
Jeff Hao201803f2013-11-20 18:11:39 -0800696if [ "$runtime" = "dalvik" ]; then
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700697 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray93d68462018-01-02 11:59:45 +0000698 framework="${ANDROID_PRODUCT_OUT}/system/framework"
Victor Chang759845f2019-08-06 16:04:36 +0100699 bpath="${framework}/core-icu4j.jar:${framework}/core-libart.jar:${framework}/core-oj.jar:${framework}/conscrypt.jar:${framework}/okhttp.jar:${framework}/bouncycastle.jar:${framework}/ext.jar"
Andreas Gampe11410de2019-07-02 15:53:53 -0700700 run_args+=(--boot --runtime-option "-Xbootclasspath:${bpath}")
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700701 else
702 true # defaults to using target BOOTCLASSPATH
703 fi
Jeff Hao201803f2013-11-20 18:11:39 -0800704elif [ "$runtime" = "art" ]; then
Ulya Trafimovich5439f052020-07-29 10:03:46 +0100705 if [ "$target_mode" = "no" ]; then
David Brazdil853a4c32015-09-28 16:15:50 +0100706 guess_host_arch_name
Martin Stjernholm9fde2db2020-10-15 16:03:29 +0100707 run_args+=(--boot "${ANDROID_HOST_OUT}/apex/art_boot_images/javalib/boot.art")
Andreas Gampe11410de2019-07-02 15:53:53 -0700708 run_args+=(--runtime-option "-Djava.library.path=${host_lib_root}/lib${suffix64}:${host_lib_root}/nativetest${suffix64}")
Jeff Hao201803f2013-11-20 18:11:39 -0800709 else
David Brazdil853a4c32015-09-28 16:15:50 +0100710 guess_target_arch_name
Martin Stjernholm0d0f8df2021-04-28 16:47:01 +0100711 # Note that libarttest(d).so and other test libraries that depend on ART
712 # internal libraries must not be in this path for JNI libraries - they
713 # need to be loaded through LD_LIBRARY_PATH and
714 # NATIVELOADER_DEFAULT_NAMESPACE_LIBS instead.
Andreas Gampe11410de2019-07-02 15:53:53 -0700715 run_args+=(--runtime-option "-Djava.library.path=/data/nativetest${suffix64}/art/${target_arch_name}")
David Srbecky928d28e2020-04-01 17:50:51 +0100716 run_args+=(--boot "/apex/com.android.art/javalib/boot.art")
Jeff Hao201803f2013-11-20 18:11:39 -0800717 fi
Alex Lighta59dd802014-07-02 16:28:08 -0700718 if [ "$relocate" = "yes" ]; then
Andreas Gampe11410de2019-07-02 15:53:53 -0700719 run_args+=(--relocate)
Alex Lighta59dd802014-07-02 16:28:08 -0700720 else
Andreas Gampe11410de2019-07-02 15:53:53 -0700721 run_args+=(--no-relocate)
Alex Lighta59dd802014-07-02 16:28:08 -0700722 fi
Andreas Gampe3f1dc562015-05-18 15:52:22 -0700723elif [ "$runtime" = "jvm" ]; then
724 # TODO: Detect whether the host is 32-bit or 64-bit.
Andreas Gampe11410de2019-07-02 15:53:53 -0700725 run_args+=(--runtime-option "-Djava.library.path=${ANDROID_HOST_OUT}/lib64:${ANDROID_HOST_OUT}/nativetest64")
Brian Carlstromdc959ea2013-10-28 00:44:49 -0700726fi
727
Alex Light03a112d2014-08-25 13:25:56 -0700728if [ "$have_image" = "no" ]; then
Alex Light1ef4ce82014-08-27 11:13:47 -0700729 if [ "$runtime" != "art" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700730 err_echo "--no-image is only supported on the art runtime"
Alex Light1ef4ce82014-08-27 11:13:47 -0700731 exit 1
732 fi
Andreas Gampe11410de2019-07-02 15:53:53 -0700733 run_args+=(--no-image)
Alex Light03a112d2014-08-25 13:25:56 -0700734fi
735
Alex Light8d94ddd2019-12-18 11:13:03 -0800736if [ "$create_runner" = "yes" -a "$target_mode" = "yes" ]; then
737 err_echo "--create-runner does not function for non --host tests"
738 usage="yes"
739fi
740
jeffhao5d1ac922011-09-29 17:41:15 -0700741if [ "$dev_mode" = "yes" -a "$update_mode" = "yes" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700742 err_echo "--dev and --update are mutually exclusive"
743 usage="yes"
744fi
745
746if [ "$dev_mode" = "yes" -a "$quiet" = "yes" ]; then
747 err_echo "--dev and --quiet are mutually exclusive"
jeffhao5d1ac922011-09-29 17:41:15 -0700748 usage="yes"
749fi
750
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700751if [ "$bisection_search" = "yes" -a "$prebuild_mode" = "yes" ]; then
752 err_echo "--bisection-search and --prebuild are mutually exclusive"
753 usage="yes"
754fi
755
Roland Levillain76cfe612017-10-30 13:14:28 +0000756# TODO: Chroot-based bisection search is not supported yet (see below); implement it.
757if [ "$bisection_search" = "yes" -a -n "$chroot" ]; then
758 err_echo "--chroot with --bisection-search is unsupported"
759 exit 1
760fi
761
jeffhao5d1ac922011-09-29 17:41:15 -0700762if [ "$usage" = "no" ]; then
763 if [ "x$1" = "x" -o "x$1" = "x-" ]; then
764 test_dir=`basename "$oldwd"`
765 else
766 test_dir="$1"
767 fi
768
769 if [ '!' -d "$test_dir" ]; then
770 td2=`echo ${test_dir}-*`
771 if [ '!' -d "$td2" ]; then
Alex Light91de25f2015-10-28 17:00:06 -0700772 err_echo "${test_dir}: no such test directory"
jeffhao5d1ac922011-09-29 17:41:15 -0700773 usage="yes"
774 fi
775 test_dir="$td2"
776 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700777 # Shift to get rid of the test name argument. The rest of the arguments
778 # will get passed to the test run.
779 shift
780fi
781
782if [ "$usage" = "yes" ]; then
783 prog=`basename $prog`
784 (
785 echo "usage:"
786 echo " $prog --help Print this message."
787 echo " $prog [options] [test-name] Run test normally."
788 echo " $prog --dev [options] [test-name] Development mode" \
789 "(dumps to stdout)."
Alex Light8d94ddd2019-12-18 11:13:03 -0800790 echo " $prog --create-runner [options] [test-name]"
791 echo " Creates a runner script for use with other " \
792 "tools (e.g. parallel_run.py)."
793 echo " The script will only run the test portion, and " \
794 "share oat and dex files."
jeffhao5d1ac922011-09-29 17:41:15 -0700795 echo " $prog --update [options] [test-name] Update mode" \
Roland Levillainb15e8792020-10-28 12:20:59 +0000796 "(replaces expected-stdout.txt and expected-stderr.txt)."
jeffhao5d1ac922011-09-29 17:41:15 -0700797 echo ' Omitting the test name or specifying "-" will use the' \
798 "current directory."
799 echo " Runtime Options:"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000800 echo " -O Run non-debug rather than debug build (off by default)."
801 echo " -Xcompiler-option Pass an option to the compiler."
Orion Hodsone1fb77f2017-02-27 13:57:18 +0000802 echo " --build-option Pass an option to the build script."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000803 echo " --runtime-option Pass an option to the runtime."
Mathieu Chartierdcd56c92017-11-20 20:30:24 -0800804 echo " --compact-dex-level Specify a compact dex level to the compiler."
Alex Lightc281ba52017-10-11 11:35:55 -0700805 echo " --debug Wait for the default debugger to attach."
806 echo " --debug-agent <agent-path>"
807 echo " Wait for the given debugger agent to attach. Currently"
808 echo " only supported on host."
809 echo " --debug-wrap-agent use libwrapagentproperties and tools/libjdwp-compat.props"
810 echo " to load the debugger agent specified by --debug-agent."
Alex Light0e151e72017-10-25 10:50:35 -0700811 echo " --with-agent <agent> Run the test with the given agent loaded with -agentpath:"
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000812 echo " --debuggable Whether to compile Java code for a debugger."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000813 echo " --gdb Run under gdb; incompatible with some tests."
Alex Lighte4b4a182019-02-12 14:19:49 -0800814 echo " --gdbserver Start gdbserver (defaults to port :5039)."
815 echo " --gdbserver-port <port>"
816 echo " Start gdbserver with the given COMM (see man gdbserver)."
817 echo " --gdbserver-bin <binary>"
818 echo " Use the given binary as gdbserver."
819 echo " --gdb-arg Pass an option to gdb or gdbserver."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000820 echo " --build-only Build test files only (off by default)."
David Srbeckyca15b8d2021-04-23 12:25:08 +0100821 echo " --skip-build Assume that test files are already built (off by default)."
822 echo " --build-path [path] Location where to store or expect the build files."
823 echo " --temp-path [path] Location where to execute the tests."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000824 echo " --interpreter Enable interpreter only mode (off by default)."
Mathieu Chartiere5f13e52015-02-24 09:37:21 -0800825 echo " --jit Enable jit (off by default)."
Nicolas Geoffray0e071252015-03-21 13:43:15 +0000826 echo " --optimizing Enable optimizing compiler (default)."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000827 echo " --no-verify Turn off verification (on by default)."
Igor Murashkin7617abd2015-07-10 18:27:47 -0700828 echo " --verify-soft-fail Force soft fail verification (off by default)."
829 echo " Verification is enabled if neither --no-verify"
830 echo " nor --verify-soft-fail is specified."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000831 echo " --no-optimize Turn off optimization (on by default)."
832 echo " --no-precise Turn off precise GC (on by default)."
833 echo " --zygote Spawn the process from the Zygote." \
jeffhao5d1ac922011-09-29 17:41:15 -0700834 "If used, then the"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000835 echo " other runtime options are ignored."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000836 echo " --prebuild Run dex2oat on the files before starting test. (default)"
837 echo " --no-prebuild Do not run dex2oat on the files before starting"
838 echo " the test."
Richard Uhler76f5cb62016-04-04 13:30:16 -0700839 echo " --strip-dex Strip the dex files before starting test."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000840 echo " --relocate Force the use of relocating in the test, making"
841 echo " the image and oat files be relocated to a random"
Nicolas Geoffray94e25db2017-01-27 14:54:28 +0000842 echo " address before running."
843 echo " --no-relocate Force the use of no relocating in the test. (default)"
Alex Lightfadfee92015-10-28 09:40:10 -0700844 echo " --image Run the test using a precompiled boot image. (default)"
845 echo " --no-image Run the test without a precompiled boot image."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000846 echo " --host Use the host-mode virtual machine."
847 echo " --invoke-with Pass --invoke-with option to runtime."
848 echo " --dalvik Use Dalvik (off by default)."
849 echo " --jvm Use a host-local RI virtual machine."
Alex Lighteb7c1442015-08-31 13:17:42 -0700850 echo " --use-java-home Use the JAVA_HOME environment variable"
851 echo " to find the java compiler and runtime"
852 echo " (if applicable) to run the test with."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000853 echo " --64 Run the test in 64-bit mode"
Alex Light680cbf22018-10-31 11:00:19 -0700854 echo " --bionic Use the (host, 64-bit only) linux_bionic libc runtime"
Alex Light20802ca2018-12-05 15:36:03 -0800855 echo " --runtime-zipapex [file]"
856 echo " Use the given zipapex file to provide runtime binaries"
Alex Light6f342dd2019-03-27 17:15:42 +0000857 echo " --runtime-extracted-zipapex [dir]"
858 echo " Use the given extracted zipapex directory to provide"
859 echo " runtime binaries"
Martin Stjernholm4815e722019-09-24 16:20:09 +0100860 echo " --timeout n Test timeout in seconds"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000861 echo " --trace Run with method tracing"
Alex Lightfadfee92015-10-28 09:40:10 -0700862 echo " --strace Run with syscall tracing from strace."
Andreas Gampe7526d782015-06-22 22:53:45 -0700863 echo " --stream Run method tracing in streaming mode (requires --trace)"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000864 echo " --gcstress Run with gc stress testing"
865 echo " --gcverify Run with gc verification"
Alex Lightb7edcda2017-04-27 13:20:31 -0700866 echo " --jvmti-trace-stress Run with jvmti method tracing stress testing"
Alex Lightc38c3692017-06-27 15:45:14 -0700867 echo " --jvmti-step-stress Run with jvmti single step stress testing"
Alex Lightb7edcda2017-04-27 13:20:31 -0700868 echo " --jvmti-redefine-stress"
869 echo " Run with jvmti method redefinition stress testing"
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000870 echo " --always-clean Delete the test files even if the test fails."
Igor Murashkin05f30e12015-06-10 15:57:17 -0700871 echo " --never-clean Keep the test files even if the test succeeds."
Roland Levillain76cfe612017-10-30 13:14:28 +0000872 echo " --chroot [newroot] Run with root directory set to newroot."
Nicolas Geoffrayc8f23fc2014-10-28 17:59:47 +0000873 echo " --android-root [path] The path on target for the android root. (/system by default)."
Victor Chang64611242019-07-05 16:32:41 +0100874 echo " --android-i18n-root [path]"
875 echo " The path on target for the i18n module root."
876 echo " (/apex/com.android.i18n by default)."
Martin Stjernholme58624f2019-09-20 15:53:40 +0100877 echo " --android-art-root [path]"
878 echo " The path on target for the ART module root."
Martin Stjernholmd6be5da2019-07-16 17:14:46 +0100879 echo " (/apex/com.android.art by default)."
Roland Levillain90b34572019-06-14 15:23:15 +0100880 echo " --android-tzdata-root [path]"
881 echo " The path on target for the Android Time Zone Data root."
882 echo " (/apex/com.android.tzdata by default)."
Nicolas Geoffray43c162f2015-03-09 12:21:26 +0000883 echo " --dex2oat-swap Use a dex2oat swap file."
Andreas Gampe4d2ef332015-08-05 09:24:45 -0700884 echo " --instruction-set-features [string]"
885 echo " Set instruction-set-features for compilation."
Alex Light91de25f2015-10-28 17:00:06 -0700886 echo " --quiet Don't print anything except failure messages"
Orion Hodson9ca92fb2020-10-28 15:08:11 +0000887 echo " --external-log-tags Use ANDROID_LOG_TAGS to set a custom logging level for"
888 echo " a test run."
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -0700889 echo " --bisection-search Perform bisection bug search."
Nicolas Geoffrayb0bbe8e2016-11-19 10:42:37 +0000890 echo " --vdex Test using vdex as in input to dex2oat. Only works with --prebuild."
Mathieu Chartier3fceaf52017-01-22 13:33:40 -0800891 echo " --suspend-timeout Change thread suspend timeout ms (default 500000)."
Shubham Ajmera981d99c2017-08-17 14:11:08 -0700892 echo " --dex2oat-jobs Number of dex2oat jobs."
Alex Light91de25f2015-10-28 17:00:06 -0700893 ) 1>&2 # Direct to stderr so usage is not printed if --quiet is set.
jeffhao5d1ac922011-09-29 17:41:15 -0700894 exit 1
895fi
896
897cd "$test_dir"
898test_dir=`pwd`
899
900td_info="${test_dir}/${info}"
Roland Levillainb15e8792020-10-28 12:20:59 +0000901td_expected_stdout="${test_dir}/${expected_stdout}"
902td_expected_stderr="${test_dir}/${expected_stderr}"
jeffhao5d1ac922011-09-29 17:41:15 -0700903
Roland Levillainb15e8792020-10-28 12:20:59 +0000904for td_file in "$td_info" "$td_expected_stdout" "$td_expected_stderr"; do
905 if [ ! -r "$td_file" ]; then
906 err_echo "${test_dir}: missing file $td_file"
907 exit 1
908 fi
909done
jeffhao5d1ac922011-09-29 17:41:15 -0700910
David Srbeckyca15b8d2021-04-23 12:25:08 +0100911if [ "$skip_build" = "no" ]; then
912 echo "${test_dir}: building..." 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -0700913
David Srbeckyca15b8d2021-04-23 12:25:08 +0100914 rm -rf "$build_path"
915 cp -LRp "$test_dir" "$build_path"
916 cd "$build_path"
jeffhao5d1ac922011-09-29 17:41:15 -0700917
David Srbeckyca15b8d2021-04-23 12:25:08 +0100918 if [ '!' -r "$build" ]; then
919 cp "${progdir}/etc/default-build" build
920 else
921 cp "${progdir}/etc/default-build" .
922 fi
jeffhao5d1ac922011-09-29 17:41:15 -0700923
David Srbeckyca15b8d2021-04-23 12:25:08 +0100924 if [ '!' -r "$run" ]; then
925 cp "${progdir}/etc/default-run" run
926 else
927 cp "${progdir}/etc/default-run" .
928 fi
929
930 if [ '!' -r "$check_cmd" ]; then
931 cp "${progdir}/etc/default-check" check
932 else
933 cp "${progdir}/etc/default-check" .
934 fi
935
936 chmod 755 "$build"
937 chmod 755 "$run"
938 chmod 755 "$check_cmd"
jeffhao5d1ac922011-09-29 17:41:15 -0700939fi
David Srbeckyca15b8d2021-04-23 12:25:08 +0100940cd "$build_path"
jeffhao5d1ac922011-09-29 17:41:15 -0700941
Elliott Hughes8cbc8bc2011-10-04 11:19:45 -0700942export TEST_NAME=`basename ${test_dir}`
943
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000944# Tests named '<number>-checker-*' will also have their CFGs verified with
945# Checker when compiled with Optimizing on host.
Stelios Ioannou1b621222021-06-17 14:15:45 +0100946# Additionally, if the user specifies that the CFG must be dumped, it will
947# run the checker for any type of test to generate the CFG.
948if [[ "$TEST_NAME" =~ ^[0-9]+-checker- ]] || [ "$dump_cfg" = "true" ]; then
Nicolas Geoffray8c41a0b2020-02-06 16:52:11 +0000949 if [ "$runtime" = "art" -a "$run_optimizing" = "true" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000950 # In no-prebuild or no-image mode, the compiler only quickens so disable the checker.
951 if [ "$prebuild_mode" = "yes" -a "$have_image" = "yes" ]; then
952 run_checker="yes"
953
Ulya Trafimovich5439f052020-07-29 10:03:46 +0100954 if [ "$target_mode" = "no" ]; then
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000955 cfg_output_dir="$tmp_dir"
956 checker_args="--arch=${host_arch_name^^}"
957 else
958 cfg_output_dir="$DEX_LOCATION"
959 checker_args="--arch=${target_arch_name^^}"
960 fi
961
962 if [ "$debuggable" = "yes" ]; then
963 checker_args="$checker_args --debuggable"
964 fi
965
Andreas Gampe11410de2019-07-02 15:53:53 -0700966 run_args+=(-Xcompiler-option "--dump-cfg=$cfg_output_dir/$cfg_output" -Xcompiler-option -j1)
Daniil Riazanovskiybfe8fc82020-10-05 15:07:15 +0000967 checker_args="$checker_args --print-cfg"
Nicolas Geoffray1949baf2017-10-17 12:14:53 +0000968 fi
969 fi
970fi
971
Andreas Gampe11410de2019-07-02 15:53:53 -0700972run_args+=(--testlib "${testlib}")
Mathieu Chartier031768a2015-08-27 10:25:02 -0700973
Alex Light20802ca2018-12-05 15:36:03 -0800974if ! ulimit -f ${file_ulimit}; then
Richard Uhler020c0f32017-03-14 16:23:17 +0000975 err_echo "ulimit file size setting failed"
Ian Rogers997f0f92014-06-21 22:58:05 -0700976fi
977
Igor Murashkin2de6e082018-02-28 15:25:23 -0800978# Tell the build script which mode (target, host, jvm) we are building for
979# to determine the bootclasspath at build time.
Igor Murashkin2a337752017-06-16 14:34:40 +0000980if [[ "$target_mode" == "yes" ]]; then
981 build_args="$build_args --target"
982else
Igor Murashkin2de6e082018-02-28 15:25:23 -0800983 if [[ $runtime == "jvm" ]]; then
984 build_args="$build_args --jvm"
985 else
986 build_args="$build_args --host"
987 fi
Igor Murashkin2a337752017-06-16 14:34:40 +0000988fi
989
990if [[ "$dev_mode" == "yes" ]]; then
991 build_args="$build_args --dev"
992fi
993
David Srbeckyca15b8d2021-04-23 12:25:08 +0100994# Build needed files, and copy them to the directory that will run the tests.
995if [ "$skip_build" = "yes" ]; then
996 # Assume the directory already contains all the needed files.
997 # Load the exit code, since builds can intentionally fail.
998 build_exit=`cat ./build_exit_code`
999elif [ "$dev_mode" = "yes" ]; then
1000 "./${build}" $build_args
1001 build_exit="$?"
1002 echo "build exit status: $build_exit" 1>&2
1003 echo "$build_exit" > ./build_exit_code
1004else
1005 "./${build}" $build_args >"$build_stdout" 2>"$build_stderr"
1006 build_exit="$?"
1007 echo "$build_exit" > ./build_exit_code
1008fi
1009rm -rf "$tmp_dir"
1010cp -LRp "$build_path" "$tmp_dir"
1011cd "$tmp_dir"
1012
jeffhao5d1ac922011-09-29 17:41:15 -07001013good="no"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001014good_build="yes"
1015good_run="yes"
Alex Light77fee872017-09-05 14:51:49 -07001016export TEST_RUNTIME="${runtime}"
jeffhao5d1ac922011-09-29 17:41:15 -07001017if [ "$dev_mode" = "yes" ]; then
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -07001018 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -08001019 echo "${test_dir}: running..." 1>&2
Roland Levillainb15e8792020-10-28 12:20:59 +00001020 "./${run}" "${run_args[@]}" "$@"
Brian Carlstromdc959ea2013-10-28 00:44:49 -07001021 run_exit="$?"
Calin Juravle3cf48772015-01-26 16:47:33 +00001022
Brian Carlstrom700c8d32012-11-05 10:42:02 -08001023 if [ "$run_exit" = "0" ]; then
Calin Juravle3cf48772015-01-26 16:47:33 +00001024 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001025 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001026 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001027 fi
David Brazdil5cc343d2015-10-08 11:35:32 +01001028 "$checker" $checker_args "$cfg_output" "$tmp_dir" 2>&1
Calin Juravle3cf48772015-01-26 16:47:33 +00001029 checker_exit="$?"
1030 if [ "$checker_exit" = "0" ]; then
1031 good="yes"
1032 fi
Alex Light91de25f2015-10-28 17:00:06 -07001033 err_echo "checker exit status: $checker_exit"
Calin Juravle3cf48772015-01-26 16:47:33 +00001034 else
1035 good="yes"
1036 fi
Brian Carlstrom700c8d32012-11-05 10:42:02 -08001037 fi
Calin Juravle3cf48772015-01-26 16:47:33 +00001038 echo "run exit status: $run_exit" 1>&2
Elliott Hughes7ab3a2a2012-06-18 16:34:20 -07001039 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001040elif [ "$update_mode" = "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -07001041 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -08001042 echo "${test_dir}: running..." 1>&2
Roland Levillainb15e8792020-10-28 12:20:59 +00001043 "./${run}" "${run_args[@]}" "$@" >"$test_stdout" 2>"$test_stderr"
David Brazdil4846d132015-01-15 19:07:08 +00001044 if [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001045 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001046 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001047 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001048 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >>"$test_stdout" 2>>"$test_stderr"
David Brazdil4846d132015-01-15 19:07:08 +00001049 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001050 sed -e 's/[[:cntrl:]]$//g' <"$test_stdout" >"${td_expected_stdout}"
1051 sed -e 's/[[:cntrl:]]$//g' <"$test_stderr" >"${td_expected_stderr}"
jeffhao5d1ac922011-09-29 17:41:15 -07001052 good="yes"
1053 else
Roland Levillainb15e8792020-10-28 12:20:59 +00001054 err_echo "#################### build standard output"
1055 cat "$build_stdout" 1>&${real_stderr}
1056 err_echo "####################"
1057 err_echo "#################### build standard error"
1058 cat "$build_stderr" 1>&${real_stderr}
1059 err_echo "####################"
Alex Light91de25f2015-10-28 17:00:06 -07001060 err_echo "build exit status: $build_exit"
jeffhao5d1ac922011-09-29 17:41:15 -07001061 fi
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001062elif [ "$build_only" = "yes" ]; then
1063 good="yes"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001064 if [ "$build_exit" '!=' '0' ]; then
Roland Levillainb15e8792020-10-28 12:20:59 +00001065 cp "$build_stdout" "$test_stdout"
1066 diff --strip-trailing-cr -q "$expected_stdout" "$test_stdout" >/dev/null
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001067 if [ "$?" '!=' "0" ]; then
1068 good="no"
Roland Levillainb15e8792020-10-28 12:20:59 +00001069 err_echo "BUILD FAILED For ${TEST_NAME}" \
1070 "(the build's standard output does not match the expected standard output)"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001071 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001072 cp "$build_stderr" "$test_stderr"
1073 diff --strip-trailing-cr -q "$expected_stderr" "$test_stderr" >/dev/null
1074 if [ "$?" '!=' "0" ]; then
1075 good="no"
1076 err_echo "BUILD FAILED For ${TEST_NAME}" \
1077 "(the build's standard error does not match the expected standard error)"
1078 fi
1079 echo "build exit status: $build_exit" >>"$test_stderr"
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001080 fi
Tsu Chiang Chuang379e2f52013-08-20 12:24:52 -07001081 # Clean up extraneous files that are not used by tests.
Roland Levillainb15e8792020-10-28 12:20:59 +00001082 find $tmp_dir -mindepth 1 \
1083 ! -regex ".*/\(.*jar\|$test_stdout\|$expected_stdout|$test_stderr\|$expected_stderr\)" \
1084 | xargs rm -rf
Tsu Chiang Chuang011fade2012-07-09 18:34:47 -07001085 exit 0
jeffhao5d1ac922011-09-29 17:41:15 -07001086else
jeffhao5d1ac922011-09-29 17:41:15 -07001087 if [ "$build_exit" = '0' ]; then
Elliott Hughes2bfc6732012-11-27 20:40:51 -08001088 echo "${test_dir}: running..." 1>&2
Roland Levillainb15e8792020-10-28 12:20:59 +00001089 "./${run}" "${run_args[@]}" "$@" >"$test_stdout" 2>"$test_stderr"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001090 run_exit="$?"
1091 if [ "$run_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -07001092 err_echo "run exit status: $run_exit"
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001093 good_run="no"
David Brazdil4846d132015-01-15 19:07:08 +00001094 elif [ "$run_checker" = "yes" ]; then
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001095 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001096 adb pull "$chroot/$cfg_output_dir/$cfg_output" &> /dev/null
Alexandre Rames5e2c8d32015-08-06 14:49:28 +01001097 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001098 "$checker" -q $checker_args "$cfg_output" "$tmp_dir" >>"$test_stdout" 2>>"$test_stderr"
David Brazdil4846d132015-01-15 19:07:08 +00001099 checker_exit="$?"
1100 if [ "$checker_exit" != "0" ]; then
Alex Light91de25f2015-10-28 17:00:06 -07001101 err_echo "checker exit status: $checker_exit"
David Brazdil4846d132015-01-15 19:07:08 +00001102 good_run="no"
1103 else
1104 good_run="yes"
1105 fi
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001106 else
1107 good_run="yes"
1108 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001109 else
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001110 good_build="no"
Roland Levillainb15e8792020-10-28 12:20:59 +00001111 cp "$build_stdout" "$test_stdout"
1112 cp "$build_stderr" "$test_stderr"
1113 echo "Failed to build in tmpdir=${tmp_dir} from oldwd=${oldwd} and cwd=`pwd`" \
1114 >> "$test_stderr"
1115 echo "Non-canonical tmpdir was ${noncanonical_tmp_dir}" >> "$test_stderr"
1116 echo "Args: ${args}" >> "$test_stderr"
1117 echo "build exit status: $build_exit" >> "$test_stderr"
Andreas Gampe5c114902014-10-27 17:03:58 -07001118 max_name_length=$(getconf NAME_MAX ${tmp_dir})
Roland Levillainb15e8792020-10-28 12:20:59 +00001119 echo "Max filename (NAME_MAX): ${max_name_length}" >> "$test_stderr"
Andreas Gampe5c114902014-10-27 17:03:58 -07001120 max_path_length=$(getconf PATH_MAX ${tmp_dir})
Roland Levillainb15e8792020-10-28 12:20:59 +00001121 echo "Max pathlength (PATH_MAX): ${max_path_length}" >> "$test_stderr"
jeffhao5d1ac922011-09-29 17:41:15 -07001122 fi
Roland Levillainb15e8792020-10-28 12:20:59 +00001123 ./$check_cmd "$expected_stdout" "$test_stdout" "$expected_stderr" "$test_stderr"
jeffhao5d1ac922011-09-29 17:41:15 -07001124 if [ "$?" = "0" ]; then
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001125 if [ "$good_build" = "no" -o "$good_run" = "yes" ]; then
Roland Levillainb15e8792020-10-28 12:20:59 +00001126 # test_stdout == expected_stdout && test_stderr == expected_stderr
Nicolas Geoffray1ed097d2014-11-13 15:15:39 +00001127 good="yes"
1128 echo "${test_dir}: succeeded!" 1>&2
1129 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001130 fi
1131fi
1132
jeffhao5d1ac922011-09-29 17:41:15 -07001133(
Alex Lightbfac14a2014-07-30 09:41:21 -07001134 if [ "$good" != "yes" -a "$update_mode" != "yes" ]; then
jeffhao5d1ac922011-09-29 17:41:15 -07001135 echo "${test_dir}: FAILED!"
1136 echo ' '
1137 echo '#################### info'
1138 cat "${td_info}" | sed 's/^/# /g'
Roland Levillainb15e8792020-10-28 12:20:59 +00001139 echo '#################### stdout diffs'
Nicolas Geoffray30a11eb2020-01-28 16:04:01 +00001140 if [ "$run_checker" == "yes" ]; then
1141 # Checker failures dump the whole CFG, so we output the whole diff.
Roland Levillainb15e8792020-10-28 12:20:59 +00001142 diff --strip-trailing-cr -u "$expected_stdout" "$test_stdout"
Nicolas Geoffray30a11eb2020-01-28 16:04:01 +00001143 else
Roland Levillainb15e8792020-10-28 12:20:59 +00001144 diff --strip-trailing-cr -u "$expected_stdout" "$test_stdout" | tail -n 10000
Nicolas Geoffray30a11eb2020-01-28 16:04:01 +00001145 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001146 echo '####################'
Roland Levillainb15e8792020-10-28 12:20:59 +00001147 echo '#################### stderr diffs'
1148 diff --strip-trailing-cr -u "$expected_stderr" "$test_stderr" | tail -n 10000
1149 echo '####################'
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001150 if [ "$strace" = "yes" ]; then
1151 echo '#################### strace output'
Hiroshi Yamauchid630fd62015-09-04 12:52:03 -07001152 tail -n 3000 "$tmp_dir/$strace_output"
Hiroshi Yamauchi1d4184d2015-07-13 17:11:22 -07001153 echo '####################'
1154 fi
Andreas Gampee79ca192017-07-31 10:30:16 -07001155 if [ "x$target_mode" = "xno" -a "x$SANITIZE_HOST" = "xaddress" ]; then
1156 # Run the stack script to symbolize any ASAN aborts on the host for SANITIZE_HOST. The
1157 # tools used by the given ABI work for both x86 and x86-64.
Roland Levillainb15e8792020-10-28 12:20:59 +00001158 echo "ABI: 'x86_64'" | cat - "$test_stdout" "$test_stderr" \
1159 | $ANDROID_BUILD_TOP/development/scripts/stack | tail -n 3000
Andreas Gampee79ca192017-07-31 10:30:16 -07001160 fi
jeffhao5d1ac922011-09-29 17:41:15 -07001161 echo ' '
1162 fi
Alex Lightbfac14a2014-07-30 09:41:21 -07001163
Alex Light91de25f2015-10-28 17:00:06 -07001164) 2>&${real_stderr} 1>&2
Alex Lightbfac14a2014-07-30 09:41:21 -07001165
Stelios Ioannou1b621222021-06-17 14:15:45 +01001166# Copy the generated CFG to the specified path.
1167if [ $dump_cfg = "true" ]; then
1168 if [ $run_optimizing != "true" ]; then
1169 err_echo "Can't dump the .cfg if the compiler type isn't set to \"optimizing\"."
1170 else
1171 if [ "$target_mode" = "yes" ]; then
1172 adb pull $chroot/$cfg_output_dir/$cfg_output $dump_cfg_path
1173 else
1174 cp $cfg_output_dir/$cfg_output $dump_cfg_path
1175 fi
1176 fi
1177fi
1178
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001179# Attempt bisection only if the test failed.
Roland Levillain76cfe612017-10-30 13:14:28 +00001180# TODO: Implement support for chroot-based bisection search.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001181if [ "$bisection_search" = "yes" -a "$good" != "yes" ]; then
1182 # Bisecting works by skipping different optimization passes which breaks checker assertions.
1183 if [ "$run_checker" == "yes" ]; then
1184 echo "${test_dir}: not bisecting, checker test." 1>&2
1185 else
1186 # Increase file size limit, bisection search can generate large logfiles.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001187 echo "${test_dir}: bisecting..." 1>&2
1188 cwd=`pwd`
1189 maybe_device_mode=""
1190 raw_cmd=""
1191 if [ "$target_mode" = "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001192 # Produce cmdline.sh in $chroot_dex_location. "$@" is passed as a runtime option
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001193 # so that cmdline.sh forwards its arguments to dalvikvm. invoke-with is set
1194 # to exec in order to preserve pid when calling dalvikvm. This is required
1195 # for bisection search to correctly retrieve logs from device.
Andreas Gampe11410de2019-07-02 15:53:53 -07001196 "./${run}" "${run_args[@]}" --runtime-option '"$@"' --invoke-with exec --dry-run "$@" &> /dev/null
Roland Levillain76cfe612017-10-30 13:14:28 +00001197 adb shell chmod u+x "$chroot_dex_location/cmdline.sh"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001198 maybe_device_mode="--device"
1199 raw_cmd="$DEX_LOCATION/cmdline.sh"
1200 else
Andreas Gampe11410de2019-07-02 15:53:53 -07001201 raw_cmd="$cwd/${run} --external-log-tags "${run_args[@]}" $@"
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001202 fi
Roland Levillain76cfe612017-10-30 13:14:28 +00001203 # TODO: Pass a `--chroot` option to the bisection_search.py script and use it there.
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001204 $ANDROID_BUILD_TOP/art/tools/bisection_search/bisection_search.py \
1205 $maybe_device_mode \
1206 --raw-cmd="$raw_cmd" \
1207 --check-script="$cwd/check" \
Roland Levillaina073f462020-10-28 12:48:24 +00001208 --expected-output="$cwd/expected-stdout.txt" \
Wojciech Staszkiewicz0c883832016-09-26 17:51:52 -07001209 --logfile="$cwd/bisection_log.txt" \
Martin Stjernholm4815e722019-09-24 16:20:09 +01001210 --timeout=${timeout:-300}
Wojciech Staszkiewiczd7a819a2016-09-01 14:43:39 -07001211 fi
1212fi
1213
Alex Lightbfac14a2014-07-30 09:41:21 -07001214# Clean up test files.
Igor Murashkin05f30e12015-06-10 15:57:17 -07001215if [ "$always_clean" = "yes" -o "$good" = "yes" ] && [ "$never_clean" = "no" ]; then
Alex Lightbfac14a2014-07-30 09:41:21 -07001216 cd "$oldwd"
David Srbeckyca15b8d2021-04-23 12:25:08 +01001217 # Clean up build files only if we created them.
1218 if [ "$skip_build" = "no" ]; then
1219 rm -rf "$build_path"
1220 fi
Alex Lightbfac14a2014-07-30 09:41:21 -07001221 rm -rf "$tmp_dir"
1222 if [ "$target_mode" = "yes" -a "$build_exit" = "0" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001223 adb shell rm -rf $chroot_dex_location
Alex Lightbfac14a2014-07-30 09:41:21 -07001224 fi
1225 if [ "$good" = "yes" ]; then
1226 exit 0
1227 fi
1228fi
1229
1230
1231(
1232 if [ "$always_clean" = "yes" ]; then
1233 echo "${TEST_NAME} files deleted from host "
1234 if [ "$target_mode" == "yes" ]; then
1235 echo "and from target"
1236 fi
1237 else
1238 echo "${TEST_NAME} files left in ${tmp_dir} on host"
1239 if [ "$target_mode" == "yes" ]; then
Roland Levillain76cfe612017-10-30 13:14:28 +00001240 echo "and in ${chroot_dex_location} on target"
Alex Lightbfac14a2014-07-30 09:41:21 -07001241 fi
Brian Carlstrom105215d2012-06-14 12:50:44 -07001242 fi
1243
Alex Light91de25f2015-10-28 17:00:06 -07001244) 2>&${real_stderr} 1>&2
jeffhao5d1ac922011-09-29 17:41:15 -07001245
Alex Light6a870fa2016-05-31 16:36:19 -07001246if [ "$never_clean" = "yes" ] && [ "$good" = "yes" ]; then
1247 exit 0
1248else
1249 exit 1
1250fi